#include <windows.h>
#include <stdio.h>

#include "MyEditor.h"
#include "MyEditorHandler.h"
#include "resource.h"

extern HWND g_finder;
extern HWND g_goto;
extern HWND g_about;

extern "C" {
#include "appStart.h"
}

int start(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR, int nCmdShow)
{
	WNDCLASSEX wc;
	MSG Msg;
	HMODULE hmod;
  LPWSTR* argv = NULL;
  int argc;
  char file[MAX_PATH];
  MyEditorHandler* meh = MyEditorHandler::getInstance();
  meh->windowsSettings(hInstance,nCmdShow);
  
  memset(file,'\0',MAX_PATH);

	wc.cbSize		 = sizeof(WNDCLASSEX);
	wc.style		 = 0;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra	 = 0;
	wc.hInstance	 = hInstance;
	wc.hIcon		 = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_BOOK_ICON), IMAGE_ICON, 16, 16, 0);
	wc.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = g_szClassName;
	wc.hIconSm		 = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_BOOK_ICON), IMAGE_ICON, 16, 16, 0);

	if(!RegisterClassEx(&wc))
	{
		MessageBox(NULL, "Window Registration Failed!", "Error!",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}
	
	hmod = LoadLibrary("SciLexer.DLL");
	if (hmod==NULL)
	{
		MessageBox(NULL,
		"The Scintilla DLL could not be loaded.",
		"Error loading Scintilla",
		MB_OK | MB_ICONERROR);
		return 1;
	}
  
  argv = CommandLineToArgvW( GetCommandLineW(), &argc );
  for( int i = 0; i < argc; i++ )
  {
    char* argument = new char[wcslen(argv[i])+1];
    wcstombs( argument, argv[i], wcslen(argv[i]) );
    argument[wcslen(argv[i])] = '\0';
    
    if( i == 1 )
    {
      strncpy(file,argument,wcslen(argv[i]));
    }
      
    delete [] argument;
  }
  LocalFree(argv);
  
  meh->createEditor(file);
  
  HACCEL fileA = LoadAccelerators(hInstance,"FileAccel");
  HACCEL editA = LoadAccelerators(hInstance,"EditAccel");
  HACCEL searchA = LoadAccelerators(hInstance,"SearchAccel");
  HACCEL viewA = LoadAccelerators(hInstance,"ViewAccel");
	
	while(GetMessage(&Msg, NULL, 0, 0) > 0)
	{
    if(!(TranslateAccelerator(GetActiveWindow(),fileA,&Msg)   ||
         TranslateAccelerator(GetActiveWindow(),editA,&Msg)   ||
         TranslateAccelerator(GetActiveWindow(),searchA,&Msg) ||
         TranslateAccelerator(GetActiveWindow(),viewA,&Msg))
    )
    {
      if( !IsDialogMessage(g_finder,&Msg) && 
          !IsDialogMessage(g_goto,&Msg)   &&
          !IsDialogMessage(g_about,&Msg) )
      {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
      }
    }
	}
	return Msg.wParam;
}
