#ifndef __MY_EDITOR__
#define __MY_EDITOR__

#include <windows.h>
#include <shlwapi.h>

#include "keywords.h"
#include "resource.h"
#include "Scintilla.h"
#include "ScintillaController.h"

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

const char g_szClassName[] = "myWindowClass";

class MyEditor
{
private:
  HWND  _window,
        _editor;
        
  HMENU _menu;
        
  HINSTANCE _app; // this should probably be global
  
  char* _file;
  fileType_t _fType;
  
  char* _ttf;

  bool isWrap;
  
  int createWindow();
  int createEditor();
  int createMenu();
protected:
public:
  MyEditor(HINSTANCE app, int nCmdShow, char* file = NULL);
  bool setFile( char* file );
  const char* getFile() { return _file; }
  ~MyEditor();
  
  const HWND getEditor() { return _editor; }
  const HWND getWindow() { return _window; }
    
  void resizeEditor();
  bool isOwner(HWND hwnd);
  
  void setType(char* fType);
  void applyStyle(fileType_t fType);
  
  void save( bool isNew = false );
  
  void setTextToFind( char* ttf );
  void find( FindDirection dir = DOWN, char* ttf = NULL );
  
  void gotoLine( unsigned int line );
  
  void focus( void ) { SetFocus(_editor); }

  void foldAll();
  void unfoldAll();
  
  bool isDirty( void );
  
  void undo()
  { SendMessage(_editor,SCI_UNDO,0,0); }
  
  void redo()
  { SendMessage(_editor,SCI_REDO,0,0); }
  
  void cut()
  { SendMessage(_editor,SCI_CUT,0,0); }
  
  void copy()
  { SendMessage(_editor,SCI_COPY,0,0); }
  
  void paste()
  { SendMessage(_editor,SCI_PASTE,0,0); }

  void toggleWrap();
  
};

#endif
