#include "MyEditorHandler.h"

MyEditorHandler* MyEditorHandler::_me = NULL;

MyEditorHandler*
MyEditorHandler::getInstance()
{
  if( !_me ) _me = new MyEditorHandler();
  
  return _me;
}

void
MyEditorHandler::windowsSettings( HINSTANCE hin, int nCmdShow )
{
  _hin = hin;
  _nCmdShow = nCmdShow;
}

MyEditor*
MyEditorHandler::createEditor( char* file )
{
	if( !PathFileExists(file) )
		file = NULL;
		
  MyEditor* newEd = new MyEditor(_hin,_nCmdShow,file);
  
  _editorList.push_back(newEd);
  
  _top = newEd;
  
  return newEd;
}

void
MyEditorHandler::removeEditor(MyEditor* ed)
{
  vector<MyEditor*>::iterator it = _editorList.begin();
  
  for( it; it != _editorList.end(); it++ )
    if( *it == ed )
    {
      _editorList.erase(it);
      return;
    }
}

MyEditor*
MyEditorHandler::findEditor(HWND hwnd)
{
  vector<MyEditor*>::const_iterator it = _editorList.begin();
  
  for( it; it != _editorList.end(); it++ )
    if( (*it)->isOwner(hwnd) )
      return *it;
  
  return NULL;
}

bool
MyEditorHandler::isEmpty()
{
  if( _editorList.size() ) return false;
  
  return true;
}