#ifndef __MY_EDITOR_HANDLER__
#define __MY_EDITOR_HANDLER__

#include <vector>
#include <windows.h>

using namespace std;

#include "MyEditor.h"

class MyEditorHandler
{
private:
  static MyEditorHandler* _me;
  
  HINSTANCE _hin;
  int _nCmdShow;
  
  vector<MyEditor*> _editorList;
  MyEditor* _top;
  MyEditorHandler() { _top = NULL; }
protected:
public:
  static MyEditorHandler* getInstance();
  void windowsSettings(HINSTANCE hin, int nCmdShow );
  
  MyEditor* createEditor( char* file = NULL );
  
  void removeEditor(MyEditor* ed);
  MyEditor* findEditor(HWND hwnd);
  
  int editorCount() { return _editorList.size(); }
  
  MyEditor* getEditor( int edNum ) { return _editorList[edNum]; }
  
  bool isEmpty();
  
  void setTopEditor(MyEditor* top) { _top = top; }
  MyEditor* getTopEditor(void) { return _top; }
  
};

#endif